Attribute VB_Name = "asm_Neon"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

Option Explicit

' asmNeon
'
' CALL          asmNeon(ptr:lpAsmBmpPara, [fct:factor], [md], [bw])
'
' IN:           lng:ptr Points to asmBmpPara-structure
'               lng:fct 0 to 255         (default = 10)
'               lng:md  0 to 2           (default = 0)
'               bol:bw  black/white      (default = no)
'
' OUT:          bol     success
'
Function asmNeon(lpAsmBmpPara As Long, Optional fct As Long = 10, Optional _
    md As Long = 0, Optional bw As Boolean = False) As Boolean
    
    Static asm(55) As Long
    
    If asm(0) = 0 Then
        asm(0) = &HEC8B5590:  asm(1) = &H6A575653:  asm(2) = &H2C36847:   asm(3) = &HDE680000
        asm(4) = &H68000000:  asm(5) = &H3E8:       asm(6) = &H993B3668:  asm(7) = &HFC0F683F
        asm(8) = &H688ACE:    asm(9) = &H6A405FC0:  asm(10) = &H147D8B00: asm(11) = &HDDDC45DD
        asm(12) = &H558BD445: asm(13) = &HD0F28A10: asm(14) = &H80E280E2: asm(15) = &HFFB9&
        asm(16) = &HC5D8B00:  asm(17) = &HDB53D923: asm(18) = &HCAD8D045: asm(19) = &HC9D8FFD9
        asm(20) = &H75C0C6F6: asm(21) = &HD9E1D802: asm(22) = &HD05DDBE1: asm(23) = &H88C20A58
        asm(24) = &HC3FE4707: asm(25) = &HDDDF7949: asm(26) = &HDC5DD9D9: asm(27) = &H8B085D8B
        asm(28) = &H7B8B1473: asm(29) = &H20538B2C: asm(30) = &H8B1C4B8B: asm(31) = &HAD51145D
        asm(32) = &HC1D7C202: asm(33) = &HC12A08C8: asm(34) = &H8C8C1D7:  asm(35) = &HC1D7C202
        asm(36) = &H45F710C8: asm(37) = &H110:      asm(38) = &H522F7400: asm(39) = &HB60FD08B
        asm(40) = &H45AF0FC0: asm(41) = &HEAC150F0: asm(42) = &HC2B60F08: asm(43) = &HEC45AF0F
        asm(44) = &HC6B60F50: asm(45) = &HE845AF0F: asm(46) = &H5AC2035A: asm(47) = &HF799C203
        asm(48) = &HE08AE475: asm(49) = &H8A08E0C1: asm(50) = &H49AB5AC4: asm(51) = &H4A59B175
        asm(52) = &H8DF9AC75: asm(53) = &HC01BF465: asm(54) = &H5D5B5E5F: asm(55) = &H10C2
    End If
    
    ' ************************************************************
    
    Dim bar(255) As Byte
    
    asmNeon = CallWindowProc(asm(0), lpAsmBmpPara, fct, md * 64 + (bw And 1), _
        VarPtr(bar(0)))
End Function

' basNeon
'
' AUFRUF:       basNeon(src, tgt, [fct:Faktor], [md:mode], [bw])
'
' EIN:          bar:src Herkunftsdaten (ByteArray)
'               bar:tgt Zieldaten      (ByteArray)
'               lng:fct Faktor 0-255   (Vorgabe 10)
'               lng:md  Modus 0-2      (Vorgabe 1)
'               log:bw  Schwarz/Wei   (Vorgabe nein)
'
' AUS:          log     Erfolg
'
Function basNeon(src() As Byte, tgt() As Byte, Optional fct As Long = 10, Optional _
    md As Long = 1, Optional bw As Boolean = False) As Boolean
    
    Dim D1          As Double
    Dim X1          As Long
    Dim Y1          As Long
    Dim N1          As Long
    Dim bar(255)    As Byte
    
    D1 = 1 / 256 * 3.14159265358979 * 2
    
    For N1 = 0 To 255
        Select Case md
        Case 0
            bar(N1) = Abs(Cos((fct + N1) * D1) * 127 - 127)
        Case 1
            bar(N1) = (Abs(Cos((fct + N1) * D1) * 127) And 255) Or 128
        Case Else
            bar(N1) = Abs(Cos((fct + N1) * D1) * 127) And 255
        End Select
    Next
    
    For Y1 = 1 To UBound(src, 2)
        For X1 = 1 To UBound(src, 1) Step 4
            tgt(X1 + 0, Y1) = 0& + bar((src(X1 + 0, Y1) + Y1) And 255)
            tgt(X1 + 1, Y1) = 0& + bar((src(X1 + 1, Y1) - X1 / 4) And 255)
            tgt(X1 + 2, Y1) = 0& + bar((src(X1 + 2, Y1) + Y1) And 255)
            
            If bw Then
                N1 = ((71& * tgt(X1 + 0, Y1) + 707& * tgt(X1 + 1, Y1) + 222& * tgt(X1 + 2, _
                    Y1)) / 1000) And 255
                
                tgt(X1 + 0, Y1) = N1
                tgt(X1 + 1, Y1) = N1
                tgt(X1 + 2, Y1) = N1
            End If
        Next
    Next
    
    basNeon = True
End Function
